import java.io.File;

import javafx.scene.Group;;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;
import javafx.scene.image.Image;

import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.shape.DrawMode;

import javafx.scene.transform.Rotate;
import javafx.geometry.Point3D;

/**
 * GOP L[
 */
public class Kirar extends Group {

	/** C[W */
	private static Image		image		= null;

	private final int			P_1_0_0		=  0;
	private final int			P_2_0_0		=  1;
	private final int			P_3_0_0		=  2;
	private final int			P_4_0_0		=  3;
	private final int			P_5_0_0		=  4;
	private final int			P_6_0_0		=  5;

	private final int			P_1_1_0		=  6;
	private final int			P_2_1_0		=  7;
	private final int			P_3_1_0		=  8;
	private final int			P_4_1_0		=  9;
	private final int			P_5_1_0		= 10;
	private final int			P_6_1_0		= 11;

	private final int			P_0_0_1		= 12;
	private final int			P_2_1_1		= 13;
	private final int			P_5_1_1		= 14;
	private final int			P_7_0_1		= 15;

	private final int			P_0_0_3		= 16;
	private final int			P_1_1_3		= 17;
	private final int			P_2_1_3		= 18;
	private final int			P_3_1_3		= 19;
	private final int			P_4_1_3		= 20;
	private final int			P_5_1_3		= 21;
	private final int			P_6_1_3		= 22;
	private final int			P_7_0_3		= 23;

	private final int			P_1_0_4		= 24;
	private final int			P_6_0_4		= 25;

	private final int			P_2_0_5		= 26;
	private final int			P_5_0_5		= 27;

	private final int			P_3_0_6		= 28;
	private final int			P_4_0_6		= 29;

	private final int			P_2_2_1		= 30;
	private final int			P_5_2_1		= 31;

	private final int			P_2_2_2		= 32;
	private final int			P_5_2_2		= 33;
	private final int			P_2_1_2		= 34;
	private final int			P_5_1_2		= 35;

	private			float[]		points = {
		-1.5f,  0.5f,  2.0f,
		-1.0f,  0.5f,  2.0f,
		-0.5f,  0.5f,  2.0f,
		 0.5f,  0.5f,  2.0f,
		 1.0f,  0.5f,  2.0f,
		 1.5f,  0.5f,  2.0f,

		-1.5f,  0.0f,  2.0f,
		-1.0f,  0.0f,  2.0f,
		-0.5f,  0.0f,  2.0f,
		 0.5f,  0.0f,  2.0f,
		 1.0f,  0.0f,  2.0f,
		 1.5f,  0.0f,  2.0f,

		-2.0f,  0.5f,  1.0f,
		-1.0f,  0.0f,  1.0f,
		 1.0f,  0.0f,  1.0f,
		 2.0f,  0.5f,  1.0f,

		-2.0f,  0.5f, -1.0f,
		-1.5f,  0.0f, -1.0f,
		-1.0f,  0.0f, -1.0f,
		-0.5f,  0.0f, -1.0f,
		 0.5f,  0.0f, -1.0f,
		 1.0f,  0.0f, -1.0f,
		 1.5f,  0.0f, -1.0f,
		 2.0f,  0.5f, -1.0f,

		-1.5f,  0.5f, -1.5f,
		 1.5f,  0.5f, -1.5f,

		-1.0f,  0.5f, -2.0f,
		 1.0f,  0.5f, -2.0f,

		-0.5f,  0.5f, -2.5f,
		 0.5f,  0.5f, -2.5f,

		-1.0f, -0.5f,  1.0f,
		 1.0f, -0.5f,  1.0f,

		-1.0f, -0.5f,  0.0f,
		 1.0f, -0.5f,  0.0f,
		-1.0f,  0.0f,  0.0f,
		 1.0f,  0.0f,  0.0f,

	};

	/** O[ */
	private final int[]			faces_0 = {
		P_1_1_0, 0, P_0_0_1, 0, P_1_1_3, 0,
		P_0_0_1, 0, P_0_0_3, 0, P_1_1_3, 0,
		P_6_1_0, 0, P_6_1_3, 0, P_7_0_3, 0,
		P_6_1_0, 0, P_7_0_3, 0, P_7_0_1, 0,
		P_2_1_1, 0, P_2_1_3, 0, P_5_1_3, 0,
		P_2_1_1, 0, P_5_1_3, 0, P_5_1_1, 0,
		P_0_0_3, 0, P_1_0_4, 0, P_1_1_3, 0,
		P_6_1_3, 0, P_6_0_4, 0, P_7_0_3, 0,
		P_2_1_3, 0, P_2_0_5, 0, P_3_0_6, 0,
		P_2_1_3, 0, P_3_0_6, 0, P_3_1_3, 0,
		P_4_1_3, 0, P_4_0_6, 0, P_5_0_5, 0,
		P_4_1_3, 0, P_5_0_5, 0, P_5_1_3, 0,
		P_3_1_3, 0, P_3_0_6, 0, P_4_0_6, 0,
		P_3_1_3, 0, P_4_0_6, 0, P_4_1_3, 0,

		// 㕔
		P_2_2_1, 0, P_2_2_2, 0, P_5_2_2, 0,
		P_2_2_1, 0, P_5_2_2, 0, P_5_2_1, 0,
		P_5_2_1, 0, P_5_1_1, 0, P_2_1_1, 0,
		P_5_2_1, 0, P_2_1_1, 0, P_2_2_1, 0,

		// 
		P_2_2_1, 0, P_2_1_1, 0, P_2_1_2, 0,
		P_2_2_1, 0, P_2_1_2, 0, P_2_2_2, 0,
		P_5_2_2, 0, P_5_1_2, 0, P_5_1_1, 0,
		P_5_2_2, 0, P_5_1_1, 0, P_5_2_1, 0,

		// w
		P_4_1_0, 0, P_4_0_0, 0, P_3_0_0, 0,
		P_4_1_0, 0, P_3_0_0, 0, P_3_1_0, 0,
		P_6_1_0, 0, P_7_0_1, 0, P_6_0_0, 0,
		P_1_1_0, 0, P_1_0_0, 0, P_0_0_1, 0,

		// 
		P_5_0_0, 0, P_5_0_5, 0, P_2_0_5, 0,
		P_5_0_0, 0, P_2_0_5, 0, P_2_0_0, 0,
		P_5_0_5, 0, P_4_0_6, 0, P_3_0_6, 0,
		P_5_0_5, 0, P_3_0_6, 0, P_2_0_5, 0,

		P_1_0_0, 0, P_1_0_4, 0, P_0_0_3, 0,
		P_1_0_0, 0, P_0_0_3, 0, P_0_0_1, 0,
		P_6_0_0, 0, P_7_0_1, 0, P_7_0_3, 0,
		P_6_0_0, 0, P_7_0_3, 0, P_6_0_4, 0,

	};

	/**  */
	private final int[]			faces_1 = {
		P_2_2_2, 0, P_3_1_3, 0, P_4_1_3, 0,
		P_2_2_2, 0, P_4_1_3, 0, P_5_2_2, 0,
		P_2_2_2, 0, P_2_1_2, 0, P_3_1_3, 0,
		P_5_2_2, 0, P_4_1_3, 0, P_5_1_2, 0,
		P_1_1_0, 0, P_1_1_3, 0, P_2_1_3, 0,
		P_1_1_0, 0, P_2_1_3, 0, P_2_1_0, 0,
		P_5_1_0, 0, P_5_1_3, 0, P_6_1_3, 0,
		P_5_1_0, 0, P_6_1_3, 0, P_6_1_0, 0,
		P_1_1_3, 0, P_1_0_4, 0, P_2_0_5, 0,
		P_1_1_3, 0, P_2_0_5, 0, P_2_1_3, 0,
		P_5_1_3, 0, P_5_0_5, 0, P_6_0_4, 0,
		P_5_1_3, 0, P_6_0_4, 0, P_6_1_3, 0,
		P_6_1_0, 0, P_6_0_0, 0, P_5_0_0, 0,
		P_6_1_0, 0, P_5_0_0, 0, P_5_1_0, 0,
		P_2_1_0, 0, P_2_0_0, 0, P_1_0_0, 0,
		P_2_1_0, 0, P_1_0_0, 0, P_1_1_0, 0,
		P_2_0_0, 0, P_2_0_5, 0, P_1_0_4, 0,
		P_2_0_0, 0, P_1_0_4, 0, P_1_0_0, 0,
		P_6_0_0, 0, P_6_0_4, 0, P_5_0_5, 0,
		P_6_0_0, 0, P_5_0_5, 0, P_5_0_0, 0,

	};

	/** ԕ */
	private final int[]			faces_2 = {
		P_5_1_0, 0, P_5_0_0, 0, P_4_0_0, 0,
		P_5_1_0, 0, P_4_0_0, 0, P_4_1_0, 0,
		P_3_1_0, 0, P_3_0_0, 0, P_2_0_0, 0,
		P_3_1_0, 0, P_2_0_0, 0, P_2_1_0, 0,
	};

	/** eNX` */
	private final int[]			faces_3 = {
		P_2_1_0, 0, P_2_1_1, 1, P_5_1_1, 2,
		P_2_1_0, 0, P_5_1_1, 2, P_5_1_0, 3
	};

	/** _~[eNX` */
	private final float[]		texCoords = {
		0, 0
	};

	/** eNX` */
	private final float[]		texCoords_3 = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	/** rC */
	private final Color[]		COLORS = {
		Color.color(0.4, 0.0, 0.0),
		Color.color(0.5, 0.0, 0.0),
		Color.color(0.6, 0.0, 0.0),
		Color.color(0.7, 0.0, 0.0),
		Color.color(0.8, 0.0, 0.0),
		Color.color(0.9, 0.0, 0.0),
		Color.color(1.0, 0.0, 0.0)
	};

	/** bVr[ */
	private		MeshView		meshView0	= null;
	private		MeshView		meshView1	= null;
	private		MeshView		meshView2	= null;
	private		MeshView		meshView3	= null;

	/** }eA */
	private		PhongMaterial	material0	= null;
	private		PhongMaterial	material1	= null;
	private		PhongMaterial	material2	= null;
	private		PhongMaterial	material3	= null;

	/** ԕ */
	private		int				time		= 0;

	/** ]xij */
	private		double			s			= Math.random() * 2 - 1;

	static{
		// eNX`摜쐬
		String filePath = new File("imageKirar.jpg").toURI().toString();
		Kirar.image = new Image(filePath);
	}

	/**
	 * RXgN^
	 */
	public Kirar(){

		// X[p[NXĂяo
		super();

		// Xݒ
		super.setTranslateX(0);

		// Yݒ
		super.setTranslateY(0);

		// Zݒ
		super.setTranslateZ(10);

		//
		// O[
		//

		// bVr[쐬
		meshView0 = new MeshView();

		// bV쐬
		TriangleMesh mesh0 = new TriangleMesh();

		mesh0.getPoints().addAll(points);
		mesh0.getTexCoords().addAll(texCoords);
		mesh0.getFaces().addAll(faces_0);

		// }eA쐬
		material0 = new PhongMaterial();
		material0.setDiffuseColor(Color.web("808080"));

		// bVo^
		meshView0.setMesh(mesh0);
		meshView0.setMaterial(material0);

		// bVr[ǉ
		this.getChildren().add(meshView0);

		//
		// 
		//

		// bVr[쐬
		meshView1 = new MeshView();

		// bV쐬
		TriangleMesh mesh1 = new TriangleMesh();

		mesh1.getPoints().addAll(points);
		mesh1.getTexCoords().addAll(texCoords);
		mesh1.getFaces().addAll(faces_1);

		// }eA쐬
		material1 = new PhongMaterial();
		material1.setDiffuseColor(Color.web("000060"));

		// bVo^
		meshView1.setMesh(mesh1);
		meshView1.setMaterial(material1);

		// bVr[ǉ
		this.getChildren().add(meshView1);

		//
		// ԕ
		//

		// bVr[쐬
		meshView2 = new MeshView();

		// bV쐬
		TriangleMesh mesh2 = new TriangleMesh();

		mesh2.getPoints().addAll(points);
		mesh2.getTexCoords().addAll(texCoords);
		mesh2.getFaces().addAll(faces_2);

		// }eA쐬
		material2 = new PhongMaterial();
		material2.setDiffuseColor(Color.web("800000"));

		// bVo^
		meshView2.setMesh(mesh2);
		meshView2.setMaterial(material2);

		// bVr[ǉ
		this.getChildren().add(meshView2);

		//
		// eNX`
		//

		// bVr[쐬
		meshView3 = new MeshView();

		// bV쐬
		TriangleMesh mesh3 = new TriangleMesh();

		mesh3.getPoints().addAll(points);
		mesh3.getTexCoords().addAll(texCoords_3);
		mesh3.getFaces().addAll(faces_3);

		// }eA쐬
		PhongMaterial material3 = new PhongMaterial();
		material3.setDiffuseMap(Kirar.image);

		// bVo^
		meshView3.setMesh(mesh3);
		meshView3.setMaterial(material3);

		// bVr[ǉ
		this.getChildren().add(meshView3);

		// ]ݒ
		super.setRotationAxis(new Point3D(0.5, 0.4, 0.2));

	} // end Kirar

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// ԂA
		if(time % 8 == 0){

			// ł镵͋Co
			material2.setDiffuseColor(COLORS[((int)(Math.random() * 7))]);

		}

		// ԂA
		if(time % 120 == 0){

			// hԂ
			meshView0.setDrawMode(DrawMode.FILL);
			meshView1.setDrawMode(DrawMode.FILL);
			meshView2.setDrawMode(DrawMode.FILL);
			meshView3.setDrawMode(DrawMode.FILL);

			material0.setDiffuseColor(Color.web("808080"));
			material1.setDiffuseColor(Color.web("000060"));
			material2.setDiffuseColor(Color.web("800000"));


		// ԂA
		}else if(time % 120 == 60){

			// C[t[ŕ\
			meshView0.setDrawMode(DrawMode.LINE);
			meshView1.setDrawMode(DrawMode.LINE);
			meshView2.setDrawMode(DrawMode.LINE);
			meshView3.setDrawMode(DrawMode.LINE);

			material0.setDiffuseColor(Color.web("FFFFFF"));
			material1.setDiffuseColor(Color.web("FFFFFF"));
			material2.setDiffuseColor(Color.web("FFFFFF"));

		}

		// ]
		super.setRotate(getRotate() + this.s);

	} // end run

}
